#include "types.h"
#include "main.h"
#include "irq.h"

u32		IntrMainBuf[0x200];         // Buffer for interrupt main routine

extern	volatile	u16	vblcounter;
extern	void	_VCountIntr(void);
extern	void	_VBlankIntr(void);

typedef void (*IntrFuncp)(void);
void IntrDummy(void);
void VBlankIntr(void);
void VCountIntr(void);

const IntrFuncp IntrTable[14] = {
    VBlankIntr,     // V Blank interrupt
    IntrDummy,      // H Blank interrupt
    VCountIntr,     // V Counter interrupt
    IntrDummy,      // Timer 0 interrupt
    IntrDummy,      // Timer 1 interrupt
    IntrDummy,      // Timer 2 interrupt
    IntrDummy,      // Timer 3 interrupt
    IntrDummy,      // Serial communication interrupt
    IntrDummy,      // DMA 0 interrupt
    IntrDummy,      // DMA 1 interrupt
    IntrDummy,      // DMA 2 interrupt
    IntrDummy,      // DMA 3 interrupt
    IntrDummy,      // Key interrupt
    IntrDummy,      // Cassette interrupt
};

extern void intr_main(void);

void	init_irq_cack(void)
{
	DMA3Call((u32)intr_main, (u32)IntrMainBuf, 0x84000400);
    *(vu32 *)INTR_VECTOR_BUF = (vu32 )IntrMainBuf;
    *(vu16 *)REG_IME   = 1;                       		   		    // Set IME
    *(vu16 *)REG_IE    = V_BLANK_INTR_FLAG | V_COUNT_INTR_FLAG;     // V Blank interrupt permission
    *(vu16 *)REG_STAT  = STAT_V_BLANK_IF_ENABLE | STAT_V_COUNT_IF_ENABLE;
}

void VBlankIntr(void)
{
    *(u16 *)INTR_CHECK_BUF = V_BLANK_INTR_FLAG;     // Set V Blank interrupt check
	_VBlankIntr();
}

void VCountIntr(void)
{
    //*(u16 *)INTR_CHECK_BUF = V_COUNT_INTR_FLAG;     // Set V Blank interrupt check??!?! made this up...
	_VCountIntr();

}

void IntrDummy(void)
{
}



