#define V_BLANK_INTR_FLAG	0x0001      // V Blank Interrupt
#define H_BLANK_INTR_FLAG	0x0002      // H Blank Interrupt
#define V_COUNT_INTR_FLAG	0x0004      // V Counter Corresponding Interrupt
#define CPU_WRAM         	0x03000000          // CPU Internal Work RAM
#define CPU_WRAM_END     	(CPU_WRAM + 0x8000)
#define INTR_CHECK_BUF   	(CPU_WRAM_END - 0x8)// Interrupt Check
#define INTR_VECTOR_BUF  	(CPU_WRAM_END - 0x4)// Interrupt Branch Address

#define REG_BASE			0x04000000          // Registers

#define REG_IME         (REG_BASE + 0x208)  // Interrupt Master Enable
#define REG_IE          (REG_BASE + 0x200)  // Interrupt Enable
#define REG_IF          (REG_BASE + 0x202)  // Interrupt Request

#define REG_STAT        (REG_BASE + 0x4)    // Status

#define STAT_V_BLANK_IF_ENABLE  0x0008      // V Blank Interrupt Request, Enable
#define STAT_H_BLANK_IF_ENABLE  0x0010      // H Blank Interrupt Request, Enable
#define STAT_V_COUNT_IF_ENABLE  0x0020      // V Counter Corresponding Interrupt Request, Enable

typedef	volatile u32	vu32;
typedef	volatile u16	vu16;

