/*-----------------05-11-00 04:13pm-----------------
 SPRINTF stuff courtesy of Derek Leigh Gilchrist
--------------------------------------------------*/

#include "libc.h"
#include "sprite.h"
#include "types.h"
#include "main.h"

// Del`s handy sprintf function, utterly simplified for psx...!
//
// just supports '%c','%s','%d','%u','%x','%X' - thats all u need...!
//
// should support all %. and %0 stuff aswell...
//
// last touched 3:07pm 15/5/2000

#define	NULL	0
#define	isdigit(_a)	( ((_a)>='0') &&((_a)<='9') )

int	sprintf(char *buf,char *fmt, ...)
{
	register	char	*ctl;
	register	char	*ptr;
	register	int	*nxtarg;
	register	int	cc;

	int		pad, len, width;
	char		*sptr;
	char		str[32];
	int 		maxchr;
	int		digitthing;

	ctl=fmt;
	ptr=buf;
	cc = 0;
	nxtarg=(int *)&fmt+1;

	while(*ctl)
	{
		digitthing=0;

		if(*ctl!='%')
		{
			*ptr++ = *ctl++;
			++cc;
			continue;
		}
	    else
			++ctl;

		if(*ctl=='%')
		{
			*ptr++ = *ctl++;
			++cc;
			continue;
		}

		if ( *ctl=='0' )
			pad = '0';
		else
			pad = ' ';			// default padding == space

// should skip whitespace here man...

		if(isdigit(*ctl))
		{
			width = atoi(ctl++);
			while(isdigit(*ctl))
				++ctl;
		}
		else
			width = 0;

		if(*ctl=='.')
		{
 			maxchr = atoi(++ctl);
			while(isdigit(*ctl))
	  			++ctl;
		}
		else
			maxchr = 0;

		sptr = str;								// setup temp string...!

		{
			char	c;
			int		arg;


			c=*ctl++;
			arg = *nxtarg++;						// Grab the next argument!!


			if ( c=='c' )
			{
				str[0] = arg;
				str[1] = NULL;
			}
			else if ( c=='s' )
			{
				pad = ' ';
				sptr = (char *)arg;

			}
			else if ( c=='d' )
			{
				digitthing=1;
				itoa(arg,str);
			}
			else if ( c=='u' )
			{
				digitthing=1;
				itoab(arg,str,10,32);
			}
			else if ( c=='x' || c=='X' )
			{
				digitthing=1;
				c&=32;
				itoab(arg,str,16,c);		// UPPER or LOWER
			}
			else
			{
				str[0]='?';
				str[1]=0;
			}
		}

// Binary?? Nah!!! Don't need it.
//			case 'b':
//				itoab(arg,str,2,32);
//				break;
// Octal?? Nah!!!	Don't need it.
//			case 'o':
//				itoab(arg,str,8,32);
//				break;

// ok, we want to append 'sptr' onto 'ptr'
		len = strlen(sptr);

		if ( digitthing&&width )
		{
			maxchr=width-1;
			width=0;

			if ( *(sptr)!='-' )
				maxchr++;
		}

// okay, frigged to get '.' working...
		if ( maxchr && digitthing )								// '.' shit??
		{
			int l2;
			if ( maxchr>=len )
			{
				if ( *sptr=='-' )
				{
			  		*ptr++='-';
					++cc;
					sptr++;
			  		len--;
	 			}
				l2 = maxchr-len;
		    	while(l2--)
   				{
   					*ptr++ = '0';
   					++cc;
   				}
	   		}
		}


// now do final string copy + pad ??
		if(width>len)
			width = width - len;
		else
			width = 0;
// pad it...
		if ( width )
		{
			while(width--)
			{
				*ptr++ = pad;
				++cc;
			}
		}
// copy the string...
		while(len--)
		{
			*ptr++ = *sptr++;
			++cc;
		}

	}

	*ptr = 0;							// Null terminate string...
	return(cc);							// return string length!!
}


// handy any base converter....!
void	itoab(int n, char *s, int b,int cse)
{
	char *ptr;
	int lowbit;

	ptr = s;
	b >>= 1;
	do
	{
		lowbit = n & 1;
		n = (n >> 1) & 0x7fffffff;	//32767;
		*ptr = ((n % b) << 1) + lowbit;
		if(*ptr < 10)
			*ptr += '0';
		else
			*ptr += 55+cse;			// Upper or lower case a,A
		++ptr;
	} while(n /= b);
	*ptr = 0;
	reverse (s);
}

void	reverse(char *s)
{
	char *j;
	int c;

	j = s + strlen(s) - 1;
	while(s < j)
	{
		c = *s;
		*s++ = *j;
		*j-- = c;
	}
}

int	strlen(char *s)
{
	int i;

	i = 0;
	if(s == NULL)
		return(0);
	while(*s++)
		++i;
	return(i);
}

// kernighan + ritchie stylee....!!
int	atoi(char *s)
{
	int i,n;

	n=0;
	for ( i=0;s[i]>='0'&&s[i]<='9';++i )
		n=10*n+(s[i]-'0');
	return(n);
}


void	itoa(int n, char *s)
{
	int sign;
	char *ptr;
	ptr = s;
	if ((sign = n) < 0)
		n = -n;
	do
	{
		*ptr++ = n % 10 + '0';
	} while ((n = n / 10) > 0);

	if (sign < 0)
		*ptr++ = '-';
	*ptr = '\0';
	reverse(s);
}

// Not ascii cos didn't need full font.

void PrintString(int x,int y, char *s, int flags)
{
	char c;

	if (flags&TXT_CENTRE)	// Centre around X pos provided (so subtract half the string length).
		x -= (strlen(s)<<2);	// Each char 8 pixels, nice!

	while (*s != 0)
	{
		c = *s++;
		if (c >= '0' && c <= '9')
			c = FONT_START + (c - '0');
		else if (c >= 'A' && c <= 'Z')
			c = FONT_START + 10 + (c - 'A');
		else if (c == '!')
			c = FONT_START + 36;	// !
		else if (c == '@')
			c = FONT_START + 37;	// Lives.
		else if (c == ' ')
			c = FONT_START + 38;	// Space.
		else
		{
			x+=8;	// Space or invalid char.
			continue;
		}

		OAM[TxtSpr].Attrib0 = y;
		OAM[TxtSpr].Attrib1 = x;
		OAM[TxtSpr].Attrib2 = c;

		x+=8;
		TxtSpr--;
	}
}


