#define PACMAN_VEL	0xc000
#define G0VEL		0xb800
#define G1VEL		0xbc00
#define G2VEL		0xc000
#define G3VEL		0xc400
#define UNIT		0x10000
#define HALF		0x8000

#define NUM_PILLS	244
#define NUM_BOXES	322

#define TOFIXED(x)	(x<<16)
#define POS(x)		(x>>16)
#define ABS(x)		(((x)>=0)?(x):(-(x)))
#define SPR(x)		(x<<2)
#define SIN(x)		(sinus[x])
#define COS(x)		(sinus[(x+256)&1023])

#define VCOUNT   	*(volatile u16*)0x04000006
#define DISPSTAT 	*(volatile u16*)0x04000004

#define BG0HOFS   	*(volatile u16*)0x04000010
#define BG0VOFS   	*(volatile u16*)0x04000012
#define BG2VOFS   	*(volatile u16*)0x0400001a
#define BG3HOFS   	*(volatile u16*)0x0400001c
#define BG3VOFS   	*(volatile u16*)0x0400001e

#define DISPCNT  	*(u32*)0x04000000			//Sets DISPCNT to be the register for it.  Easier than using the hex every time
#define BG0CNT		*(u16*)0x04000008			//Sets BG0CNT to be the register for it.  Easier than using the hex every time
#define BG1CNT		*(u16*)0x0400000a			//Sets BG1CNT to be the register for it.  Easier than using the hex every time
#define BG2CNT		*(u16*)0x0400000c			//Sets BG2CNT to be the register for it.  Easier than using the hex every time
#define BG3CNT		*(u16*)0x0400000e			//Sets BG3CNT to be the register for it.  Easier than using the hex every time

#define MOSAICR	*(u16*)0x0400004c 			// Mosaic size reg.
#define BLDMOD		*(u16*)0x04000050
#define COLEV		*(u16*)0x04000052
#define COLY		*(u16*)0x04000054

#define P1	  	*(u16*)0x04000130			// joypad reading...

#define DMA3SAD  	*(u32*)0x040000d4			//setups up all display variables.  read the official docs for more info
#define DMA3DAD  	*(u32*)0x040000d8
#define DMA3CNT  	*(u32*)0x040000dc

#define OAM	  	((Sprite*)0x07000000)
#define OBJCHARDATA	((u8*)0x06010000)
#define OBJ_PALETTE	((u16*)0x05000200)
#define CHR_PALETTE	((u16*)0x05000000)

#define J_A		0x0001
#define J_B		0x0002
#define J_SELECT	0x0004
#define J_START	0x0008
#define J_RIGHT  	0x0010						//hex for the joypad keys we'll be using
#define J_LEFT		0x0020
#define J_UP		0x0040
#define J_DOWN		0x0080

enum { 	PACMAN=0,
		GHOST1,
		GHOST2,
		GHOST3,
		GHOST4,
		GHOST1SCORE,
		GHOST2SCORE,
		GHOST3SCORE,
		GHOST4SCORE,
		BONUS
};


enum	{	PM_UP=0,
		PM_DOWN,
		PM_LEFT,
		PM_RIGHT
};

#define NEXT_LEVEL	1
#define DEATH		2

#define REVERSE	1 	// Can turn back on itself.
#define REPEL		2	// Go away from Pacman.
#define EATEN		4	// Been eaten and on its way back to middle.
#define QUICK_TURN	8	// Can do a quick turn for 1 cycle.
#define ENTERBOX	16	// Flag set when entering middle.

#define PMHUNTER  	0 	// Hunt pacman.
#define PILLHUNTER	1	// Hunt for nearest pill to pacman.
#define CUTOFF		2	// Cut off pacmans route.
#define ROAMER		3	// Roam aimlessly around.

typedef unsigned char u8;						//some type definitions
typedef unsigned short u16;
typedef unsigned long u32;

typedef struct _Sprite
{
	u16 Attrib0;
	u16 Attrib1;
	u16 Attrib2;
	u16 RotateScale;
} Sprite;		//define a sprite as a structure

typedef struct
{
	int		x,y;
	int		xv,yv;
	int		dxv,dyv;
	short	dir;
	short	Timer;
	short 	BlueTimer;	// For when collecting power pill.
	short 	Flags;
	short 	InBox;
	short 	def;
	short 	Lives;
	short 	AITime;
	short	AIRand;
	short	NormalAI;
	short 	CurrentAI;
	short   Boxnum;
} GHOSTS;

typedef struct
{
	int		x,y;
	short	def,timer;
} SCORES;	// Pickup/ghost score sprites (timer==-1 is not displayed).

